from dict_base import 한글사전
# 사전(dict) 처리 예: 삭제 오류 처리
#----------
#----------
# ㄱ)
del 한글사전['언어'] # 사전에 없는 항목을 삭제함.
'''
처리 결과:
=========================
Traceback (most recent call last):
  File "~.py", line 6, in <module>
    del 한글사전['언어'] # 사전에 없는 항목을 삭제함.
KeyError: '언어'
'''

#----------
#----------
# ㄴ)
try:
    del 한글사전['언어'] # 사전에 없는 항목을 삭제함.
    print( "ㄴ) 삭제: 성공")
except KeyError: # '언어'
    print( "ㄴ) 삭제: 실패")
print(한글사전)
'''
처리 결과:
=========================
ㄴ) 삭제: 실패
{'표제어': '흙', '품사': '명사', '등록자': '세종대왕'}
'''

#----------
#----------
# ㄷ)
delvalue = 한글사전.pop('가격') # 사전에서 없는 '가격' 항목을 삭제함.
'''
처리 결과:
=========================
Traceback (most recent call last):
  File "~.py", line 5, in <module>
    delvalue = 한글사전.pop('가격') # 사전에서 없는 '가격' 항목을 삭제함.
KeyError: '가격'
'''

#----------
#----------
# ㄹ)
delvalue = 한글사전.pop('가격', '사전에 없는 항목입니다.') # 사전에서 없는 '가격' 항목을 삭제함.
print( "ㄹ) 삭제:", delvalue)
'''
처리 결과:
=========================
ㄹ) 삭제: 사전에 없는 항목입니다.
'''








