from sort_base import kimchi_dict
# 정렬(sorted) 처리 예: dict
# ㄱ) 
def dictkey(item):
    return item[0] # by key from (key, value)

sort_items_kf = sorted(kimchi_dict.items(), key=dictkey) # by key from (key, value)
print('ㄱ) sort_items_kf:', sort_items_kf)

# ㄴ) 
def dictvalue(item):
    return -item[1] # by value from (key, value)

sort_items_vf = sorted(kimchi_dict.items(), key=dictvalue) # by value from (key, value)
print('ㄴ) sort_items_vf:', sort_items_vf)

# ㄷ) 
sort_items_kl = sorted(kimchi_dict.items(), key=(lambda item:item[0])) # by key from (key, value)
print('ㄷ) sort_items_kl:', sort_items_kl)

# ㄹ) 
sort_items_vl = sorted(kimchi_dict.items(), key=(lambda item:-item[1]))# by value from (key, value)
print('ㄹ) sort_items_vl:', sort_items_vl)


'''
처리 결과
===========================
ㄱ) sort_items_kf: [('김치', 1578), ('김치공장', 40), ('김치국', 1), ('김치냉장고', 82), ('김치담그기', 18), ('김치독', 3), ('김치맛', 28), ('김치볶음밥', 9), ('김치비빔국수', 1), ('김치시장', 15), ('김치양념', 5), ('김치업체', 12), ('김치유산균', 16), ('김치전', 3), ('김치전골', 1), ('김치제조업체', 13), ('김치지수', 2), ('김치찌개', 38), ('김치찌게', 5), ('김치축제', 5), ('김치코너', 2), ('김치파동', 38)]
ㄴ) sort_items_vf: [('김치', 1578), ('김치냉장고', 82), ('김치공장', 40), ('김치파동', 38), ('김치찌개', 38), ('김치맛', 28), ('김치담그기', 18), ('김치유산균', 16), ('김치시장', 15), ('김치제조업체', 13), ('김치업체', 12), ('김치볶음밥', 9), ('김치찌게', 5), ('김치축제', 5), ('김치양념', 5), ('김치전', 3), ('김치독', 3), ('김치지수', 2), ('김치코너', 2), ('김치국', 1), ('김치전골', 1), ('김치비빔국수', 1)]
ㄷ) sort_items_kl: [('김치', 1578), ('김치공장', 40), ('김치국', 1), ('김치냉장고', 82), ('김치담그기', 18), ('김치독', 3), ('김치맛', 28), ('김치볶음밥', 9), ('김치비빔국수', 1), ('김치시장', 15), ('김치양념', 5), ('김치업체', 12), ('김치유산균', 16), ('김치전', 3), ('김치전골', 1), ('김치제조업체', 13), ('김치지수', 2), ('김치찌개', 38), ('김치찌게', 5), ('김치축제', 5), ('김치코너', 2), ('김치파동', 38)]
ㄹ) sort_items_vl: [('김치', 1578), ('김치냉장고', 82), ('김치공장', 40), ('김치파동', 38), ('김치찌개', 38), ('김치맛', 28), ('김치담그기', 18), ('김치유산균', 16), ('김치시장', 15), ('김치제조업체', 13), ('김치업체', 12), ('김치볶음밥', 9), ('김치찌게', 5), ('김치축제', 5), ('김치양념', 5), ('김치전', 3), ('김치독', 3), ('김치지수', 2), ('김치코너', 2), ('김치국', 1), ('김치전골', 1), ('김치비빔국수', 1)]

'''

