import hgsysinc
from hgkbd import HGTransString2KBDJamo
from hgtest import load_dictfreq_kbs_2009, load_dictfreq_kbs_01_16
from hgfind import Eng2HngChecker
#-----------------------------
#-----------------------------
#=print('reading texts')
# foramt: {'word': 1}
DictFreqList = load_dictfreq_kbs_2009() # [KBS 9시 뉴스: 2009년]
#=DictFreqList = load_dictfreq_kbs_01_16()
print('Dict Num:', len(DictFreqList))
#=WordNum = sum(DictFreqList[dic] for dic in DictFreqList)
#=print('Word Num:', WordNum)

#-----
# 사전을 두벌식 자모로 변환
#-----
DictFreq_KBDJamo = {}
for dic in DictFreqList:
    dic_jamo = HGTransString2KBDJamo(dic) # 음절을 두벌식 자모로 변환
    DictFreq_KBDJamo[dic_jamo] = int(DictFreqList[dic])

#-----
#-----
print('#==============')
print('영한 변환과 철자 오류 교정')
print('#==============')
Eng2HngChecker('gksrnr', DictFreq_KBDJamo)  # '한국' (영한변환 오류)
Eng2HngChecker('eogksalsrnr', DictFreq_KBDJamo) # '대한민국' (영한변환 오류)
Eng2HngChecker('ghksdbf', DictFreq_KBDJamo) # '환율' (영한변환 오류)

Eng2HngChecker('fksrnr', DictFreq_KBDJamo)  # '란국'<- '한국' (영한변환 오류 + 철자 오류)
Eng2HngChecker('eogjsalsrnr', DictFreq_KBDJamo) # '대헌민국'<- '대한민국' (영한변환 오류 + 철자 오류)
Eng2HngChecker('fhksdbf', DictFreq_KBDJamo) # '롼율'<-'환율'(영한변환 오류 + 철자 오류)


'''
처리 결과:
===========================
@@@ [KBS 9시 뉴스] @@@
@@@ @@@ [토큰처리] -  {주제어}
file: ..\testtext\hgdatsci\_kbs_2009_\2009.가나순_WordList.txt
Dict Num: 99989
#==============
영한 변환과 철자 오류 교정
#==============
[영한변환] gksrnr  ===>  ㅎㅏㄴㄱㅜㄱ
DisWord Num: 107


# 편집 거리 순서 출력
1: ㅎㅏㄴㄱㅜㄱ(한국) (0, 1655)
2: ㅇㅏㄴㄱㅜㄱ(안국) (1, 3)
3: ㄴㅏㄴㄱㅜㄱ(난국) (1, 2)
4: ㅎㅏㄴㄱㅗㄱ(한곡) (1, 2)
5: ㅎㅏㄴㅊㅜㄱ(한축) (1, 2)
6: ㅎㅏㄴㅅㅜㄱ(한숙) (1, 1)
7: ㅎㅏㅁㄱㅜㄱ(함국) (1, 1)
8: ㅈㅓㄴㄱㅜㄱ(전국) (2, 1812)
9: ㄱㅏㄱㄱㅜㄱ(각국) (2, 186)
10: ㄷㅏㅇㄱㅜㄱ(당국) (2, 184)
11: ㅎㅏㄴㄱㅏㅇ(한강) (2, 133)
12: ㅎㅏㄴㄱㅖ(한계) (2, 121)
13: ㅎㅏㄴㅉㅗㄱ(한쪽) (2, 115)
14: ㅂㅏㄴㄱㅕㄱ(반격) (2, 108)
15: ㅎㅏㄴㄱㅡㄹ(한글) (2, 78)
16: ㅈㅏㄱㅜㄱ(자국) (2, 73)
17: ㄷㅏㄴㅊㅜㄱ(단축) (2, 68)
18: ㅎㅏㄴㅇㅜ(한우) (2, 65)
19: ㅎㅏㅂㄱㅕㄱ(합격) (2, 58)
20: ㅎㅏㄴㅅㅣㄱ(한식) (2, 56)
21: ㄱㅏㅇㄱㅜㄱ(강국) (2, 43)
22: ㅊㅓㄴㄱㅜㄱ(천국) (2, 40)
23: ㅎㅏㄴㄴㅜㄴ(한눈) (2, 39)
24: ㅎㅏㄴㄱㅕㄹ(한결) (2, 38)
25: ㅎㅏㅇㄱㅜ(항구) (2, 34)
26: ㄱㅏㄴㄱㅕㄱ(간격) (2, 32)
27: ㅎㅏㄴㅍㅜㄹ(한풀) (2, 32)
28: ㅎㅏㄴㅇㅗㄱ(한옥) (2, 31)
29: ㅎㅏㄴㄱㅜㄱㄱㅖ(한국계) (2, 29)
30: ㅎㅏㄴㅅㅜㅁ(한숨) (2, 29)
31: ㅎㅏㄴㅍㅜㄴ(한푼) (2, 28)
32: ㅂㅏㄴㄱㅜㄴ(반군) (2, 25)
33: ㅎㅏㄴㄱㅐ(한개) (2, 25)
34: ㅎㅏㅂㅅㅜㄱ(합숙) (2, 24)
35: ㅎㅏㄴㅈㅗㄱ(한족) (2, 23)
36: ㅎㅏㄴㄱㅜㄱㅇㅓ(한국어) (2, 21)
37: ㄱㅓㄴㄱㅜㄱ(건국) (2, 20)
38: ㅇㅏㄴㄱㅜ(안구) (2, 19)
39: ㅍㅏㄱㅜㄱ(파국) (2, 19)
40: ㅎㅏㄴㅇㅑㄱ(한약) (2, 18)
41: ㅎㅏㄴㅂㅗㄱ(한복) (2, 17)
42: ㅎㅏㄴㄱㅗㅅ(한곳) (2, 16)
43: ㅎㅏㄴㄱㅗㄹ(한골) (2, 15)
44: ㅎㅏㄴㅈㅜㅇ(한중) (2, 15)
45: ㅂㅗㄴㄱㅜㄱ(본국) (2, 12)
46: ㅎㅏㄴㅈㅜ(한주) (2, 10)
47: ㅎㅕㅇㄱㅜㄱ(형국) (2, 10)
48: ㅎㅏㄱㅜ(하구) (2, 9)
49: ㄷㅏㄴㄱㅜㄴ(단군) (2, 8)
50: ㅎㅏㄴㄱㅜㄱㅊㅏ(한국차) (2, 8)
51: ㅎㅏㄴㅅㅜ(한수) (2, 8)
52: ㅎㅏㅁㄱㅜ(함구) (2, 8)
53: ㅎㅏㄱㄱㅜㄴ(학군) (2, 7)
54: ㅎㅡㅇㄱㅜㄱ(흥국) (2, 7)
55: ㅎㅏㄴㄱㅜㅅㅓㄱ(한구석) (2, 5)
56: ㅎㅏㄴㄱㅣ(한기) (2, 5)
57: ㅎㅐㄱㅜㄱ(해국) (2, 5)
58: ㅎㅗㅏㄴㄱㅏㄱ(환각) (2, 5)
59: ㅂㅏㄴㅈㅜㄱ(반죽) (2, 4)
60: ㅅㅜㄴㄱㅜㄱ(순국) (2, 4)
61: ㅌㅏㄱㅜㄱ(타국) (2, 4)
62: ㅎㅏㄴㄱㅜㄱㅅㅏ(한국사) (2, 4)
63: ㅎㅗㄱㅜㄱ(호국) (2, 4)
64: ㄱㅏㄴㄱㅗㄱ(간곡) (2, 3)
65: ㄱㅏㄴㄱㅡㄱ(간극) (2, 3)
66: ㅅㅏㅇㄱㅜㄱ(상국) (2, 3)
67: ㅇㅏㄴㄱㅜㄹ(안굴) (2, 3)
68: ㅎㅏㄴㄱㅗㅏ(한과) (2, 3)
69: ㅎㅏㄴㄱㅜㅓㄴ(한권) (2, 3)
70: ㅎㅏㄴㄷㅜㄹ(한둘) (2, 3)
71: ㅎㅏㄴㅂㅜㄴ(한분) (2, 3)
72: ㅎㅏㄴㅅㅜㄹ(한술) (2, 3)
73: ㅎㅏㄴㅈㅜㅁ(한줌) (2, 3)
74: ㅎㅏㄴㅊㅓㄱ(한척) (2, 3)
75: ㅎㅏㅁㅂㅜㄱ(함북) (2, 3)
76: ㅎㅓㅊㅏㄴㄱㅜㄱ(허찬국) (2, 3)
77: ㅎㅏㄴㄱㅏ(한가) (2, 2)
78: ㅎㅏㄴㄱㅏㅂ(한갑) (2, 2)
79: ㅎㅏㄴㄱㅜㄱㅁㅣ(한국미) (2, 2)
80: ㅎㅏㄴㄱㅜㄱㅈㅔ(한국제) (2, 2)
81: ㅎㅏㄴㄱㅡㄴ(한근) (2, 2)
82: ㅎㅏㄴㄷㅜㄱㅐ(한두개) (2, 2)
83: ㅎㅏㄴㅈㅜㄹ(한줄) (2, 2)
84: ㅎㅏㄴㅍㅗㄱ(한폭) (2, 2)
85: ㄴㅏㅁㄱㅜㄱ(남국) (2, 1)
86: ㄸㅏㄴㅈㅜㄱ(딴죽) (2, 1)
87: ㅂㅣㄴㄱㅜㄱ(빈국) (2, 1)
88: ㅅㅏㅁㄱㅜㄱ(삼국) (2, 1)
89: ㅇㅏㄴㄱㅜㄴ(안군) (2, 1)
90: ㅇㅕㄴㄱㅜㄱ(연국) (2, 1)
91: ㅊㅏㄴㄱㅜ(찬구) (2, 1)
92: ㅎㅏㄱㅐㄱ(하객) (2, 1)
93: ㅎㅏㄴ ㄱㅜ(한 구) (2, 1)
94: ㅎㅏㄴㄱㅏㅅ(한갓) (2, 1)
95: ㅎㅏㄴㄱㅓㄴ(한건) (2, 1)
96: ㅎㅏㄴㄱㅕㅇ(한경) (2, 1)
97: ㅎㅏㄴㄱㅛ(한교) (2, 1)
98: ㅎㅏㄴㄱㅜㅇㅕㄱ(한구역) (2, 1)
99: ㅎㅏㄴㄱㅜㄱㄷㅐ(한국대) (2, 1)
100: ㅎㅏㄴㄱㅜㄱㅂㅜ(한국부) (2, 1)
101: ㅎㅏㄴㄱㅜㄱㅇㅖ(한국예) (2, 1)
102: ㅎㅏㄴㄱㅜㄱㅍㅏ(한국파) (2, 1)
103: ㅎㅏㄴㄱㅣㄹ(한길) (2, 1)
104: ㅎㅏㄴㅁㅜㄴ(한문) (2, 1)
105: ㅎㅏㄴㅈㅓㄱ(한적) (2, 1)
106: ㅎㅏㄴㅈㅣㄱ(한직) (2, 1)
107: ㅎㅕㄴㄱㅗㄱ(현곡) (2, 1)

[영한변환] eogksalsrnr  ===>  ㄷㅐㅎㅏㄴㅁㅣㄴㄱㅜㄱ
DisWord Num: 6


# 편집 거리 순서 출력
1: ㄷㅐㅎㅏㄴㅁㅣㄴㄱㅜㄱ(대한민국) (0, 261)
2: ㅎㅏㄴㅁㅣㄴㄱㅜㄱ(한민국) (2, 7)
3: ㄷㅐㅎㅏㄴㅈㅔㄱㅜㄱ(대한제국) (3, 15)
4: ㅎㅏㄴㅁㅣㄴㄱㅜ(한민구) (3, 2)
5: ㄷㅐㅎㅏㄴㅁㅣㄴㅂㅗ(대한민보) (3, 1)
6: ㅈㅜㅎㅏㄴㅁㅣㄱㅜㄱ(주한미국) (3, 1)

[영한변환] ghksdbf  ===>  ㅎㅗㅏㄴㅇㅠㄹ
DisWord Num: 11


# 편집 거리 순서 출력
1: ㅎㅗㅏㄴㅇㅠㄹ(환율) (0, 220)
2: ㅎㅗㅏㄱㅇㅠㄹ(확율) (1, 2)
3: ㅎㅗㅏㄴㄹㅠㄹ(환률) (1, 2)
4: ㅇㅗㅏㄴㅇㅠㄹ(완율) (1, 1)
5: ㅎㅏㄴㅇㅣㄹ(한일) (2, 86)
6: ㅎㅗㅏㄴㅇㅕㅇ(환영) (2, 84)
7: ㅎㅗㅏㄱㄹㅠㄹ(확률) (2, 48)
8: ㅎㅗㅏㄴㅂㅜㄹ(환불) (2, 37)
9: ㄱㅗㅎㅗㅏㄴㅇㅠㄹ(고환율) (2, 10)
10: ㅎㅏㄴㅇㅏㄹ(한알) (2, 1)
11: ㅎㅗㅅㅗㅇㅠㄹ(호소율) (2, 1)

[영한변환] fksrnr  ===>  ㄹㅏㄴㄱㅜㄱ
DisWord Num: 36


# 편집 거리 순서 출력
1: ㅎㅏㄴㄱㅜㄱ(한국) (1, 1655)
2: ㅇㅏㄴㄱㅜㄱ(안국) (1, 3)
3: ㄴㅏㄴㄱㅜㄱ(난국) (1, 2)
4: ㅈㅓㄴㄱㅜㄱ(전국) (2, 1812)
5: ㄱㅏㄱㄱㅜㄱ(각국) (2, 186)
6: ㄷㅏㅇㄱㅜㄱ(당국) (2, 184)
7: ㅂㅏㄴㄱㅕㄱ(반격) (2, 108)
8: ㅈㅏㄱㅜㄱ(자국) (2, 73)
9: ㄷㅏㄴㅊㅜㄱ(단축) (2, 68)
10: ㄱㅏㅇㄱㅜㄱ(강국) (2, 43)
11: ㅊㅓㄴㄱㅜㄱ(천국) (2, 40)
12: ㄱㅏㄴㄱㅕㄱ(간격) (2, 32)
13: ㅂㅏㄴㄱㅜㄴ(반군) (2, 25)
14: ㄱㅓㄴㄱㅜㄱ(건국) (2, 20)
15: ㅇㅏㄴㄱㅜ(안구) (2, 19)
16: ㅍㅏㄱㅜㄱ(파국) (2, 19)
17: ㅂㅗㄴㄱㅜㄱ(본국) (2, 12)
18: ㄷㅏㄴㄱㅜㄴ(단군) (2, 8)
19: ㅂㅏㄴㅈㅜㄱ(반죽) (2, 4)
20: ㅅㅜㄴㄱㅜㄱ(순국) (2, 4)
21: ㅌㅏㄱㅜㄱ(타국) (2, 4)
22: ㄱㅏㄴㄱㅗㄱ(간곡) (2, 3)
23: ㄱㅏㄴㄱㅡㄱ(간극) (2, 3)
24: ㅅㅏㅇㄱㅜㄱ(상국) (2, 3)
25: ㅇㅏㄴㄱㅜㄹ(안굴) (2, 3)
26: ㅎㅏㄴㄱㅗㄱ(한곡) (2, 2)
27: ㅎㅏㄴㅊㅜㄱ(한축) (2, 2)
28: ㄴㅏㅁㄱㅜㄱ(남국) (2, 1)
29: ㄸㅏㄴㅈㅜㄱ(딴죽) (2, 1)
30: ㅂㅣㄴㄱㅜㄱ(빈국) (2, 1)
31: ㅅㅏㅁㄱㅜㄱ(삼국) (2, 1)
32: ㅇㅏㄴㄱㅜㄴ(안군) (2, 1)
33: ㅇㅕㄴㄱㅜㄱ(연국) (2, 1)
34: ㅊㅏㄴㄱㅜ(찬구) (2, 1)
35: ㅎㅏㄴㅅㅜㄱ(한숙) (2, 1)
36: ㅎㅏㅁㄱㅜㄱ(함국) (2, 1)

[영한변환] eogjsalsrnr  ===>  ㄷㅐㅎㅓㄴㅁㅣㄴㄱㅜㄱ
DisWord Num: 2


# 편집 거리 순서 출력
1: ㄷㅐㅎㅏㄴㅁㅣㄴㄱㅜㄱ(대한민국) (1, 261)
2: ㅎㅏㄴㅁㅣㄴㄱㅜㄱ(한민국) (3, 7)

[영한변환] fhksdbf  ===>  ㄹㅗㅏㄴㅇㅠㄹ
DisWord Num: 53


# 편집 거리 순서 출력
1: ㅎㅗㅏㄴㅇㅠㄹ(환율) (1, 220)
2: ㅇㅗㅏㄴㅇㅠㄹ(완율) (1, 1)
3: ㅎㅗㅏㄱㅇㅠㄹ(확율) (2, 2)
4: ㅎㅗㅏㄴㄹㅠㄹ(환률) (2, 2)
5: ㅌㅏㅇㅠㄹ(타율) (3, 115)
6: ㅎㅏㄴㅇㅣㄹ(한일) (3, 86)
7: ㅎㅗㅏㄴㅇㅕㅇ(환영) (3, 84)
8: ㅈㅗㅇㅠㄹ(조율) (3, 76)
9: ㄱㅗㅏㅇㅣㄹ(과일) (3, 61)
10: ㄱㅗㅏㄴㅇㅕ(관여) (3, 57)
11: ㄱㅗㅏㄴㅊㅏㄹ(관찰) (3, 52)
12: ㅎㅗㅏㄱㄹㅠㄹ(확률) (3, 48)
13: ㅁㅏㄴㅇㅣㄹ(만일) (3, 40)
14: ㅎㅗㅏㄴㅂㅜㄹ(환불) (3, 37)
15: ㅅㅓㄴㅇㅠㄹ(선율) (3, 36)
16: ㅈㅏㅇㅠㄹ(자율) (3, 36)
17: ㅊㅜㄹㅅㅏㄴㅇㅠㄹ(출산율) (3, 30)
18: ㄱㅗㅏㅇㅕㄹ(과열) (3, 25)
19: ㅂㅏㄴㅇㅕㄹ(반열) (3, 20)
20: ㄱㅗㅏㄴㅈㅓㄹ(관절) (3, 15)
21: ㄷㅏㄴㅇㅣㄹ(단일) (3, 14)
22: ㄱㅗㅏㄴㅎㅏㄹ(관할) (3, 12)
23: ㄹㅏㅇㅜㄹ(라울) (3, 12)
24: ㄱㅗㅎㅛㅇㅠㄹ(고효율) (3, 11)
25: ㄱㅗㅎㅗㅏㄴㅇㅠㄹ(고환율) (3, 10)
26: ㄱㅗㅏㄴㅊㅓㄹ(관철) (3, 10)
27: ㅇㅗㅐㄴㅇㅣㄹ(왠일) (3, 10)
28: ㄱㅗㅏㄴㅇㅛㅇ(관용) (3, 6)
29: ㅇㅏㄴㅇㅣㄹ(안일) (3, 4)
30: ㅌㅏㄴㅇㅏㄹ(탄알) (3, 4)
31: ㄱㅗㅏㄴㅅㅔㅇㅠㄹ(관세율) (3, 3)
32: ㅂㅣㅁㅏㄴㅇㅠㄹ(비만율) (3, 3)
33: ㅈㅓㄴㅇㅠㄹ(전율) (3, 3)
34: ㄱㅗㅏㄴㅇㅏㄱ(관악) (3, 2)
35: ㄱㅗㅏㄴㅇㅕㅇ(관영) (3, 2)
36: ㄷㅏㄴㅇㅕㄹ(단열) (3, 2)
37: ㅂㅏㄴㅇㅣㄹ(반일) (3, 2)
38: ㅇㅗㅏㄴㄱㅕㄹ(완결) (3, 2)
39: ㄱㅗㅈㅏㅇㅇㅠㄹ(고장율) (3, 1)
40: ㄱㅗㅏㄴㅇㅏ(관아) (3, 1)
41: ㄱㅗㅏㄴㅇㅗㅣ(관외) (3, 1)
42: ㄱㅜㅓㄴㅇㅠㄹ(권율) (3, 1)
43: ㄷㅗㄴㅇㅠㄱ(돈육) (3, 1)
44: ㄹㅗㅇㅑㄹ(로얄) (3, 1)
45: ㄹㅗㅇㅕㄹ(로열) (3, 1)
46: ㅂㅗㅇㅠㅇㅠㄹ(보유율) (3, 1)
47: ㅅㅣㄴㅇㅠㄹ(신율) (3, 1)
48: ㅇㅗㅊㅏㅇㅠㄹ(오차율) (3, 1)
49: ㅇㅗㅏㄴㅇㅕㄴ(완연) (3, 1)
50: ㅇㅗㅏㄴㅊㅣㅇㅠㄹ(완치율) (3, 1)
51: ㅍㅏㄴㅇㅠㄹㅣ(판유리) (3, 1)
52: ㅎㅏㄴㅇㅏㄹ(한알) (3, 1)
53: ㅎㅗㅅㅗㅇㅠㄹ(호소율) (3, 1)


'''
